<?php
/*************************************************************************** 
 * 
 *                              pnFlashGames.php 
 *                            ------------------ 
 *   begin                : Monday, Jan 8th, 2007
 *   copyright            : (c)2005 - 2007 www.phpbb-arcade.com 
 *   email                : defenders_realm@yahoo.com 
 * 
 *   $Id: pnFlashGames.php, v2.2.0 2007/01/08 11:27:24 dEfEndEr Exp $ 
 * 
 ***************************************************************************
 *
 * pnFlashGames Support for the phpBB Arcade Mod (c) 2005-2007 dEfEndEr
 *
 * Based on information from the pnFlashGames Nuke Mod (c) Lee Easton
 *
 **************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include_once($phpbb_root_path . 'extension.inc');
include_once($phpbb_root_path . 'common.'.$phpEx);
include_once($phpbb_root_path . 'includes/functions_arcade.'.$phpEx);
//
// Start session management 
//
$userdata			= session_pagestart($user_ip, PAGE_ACTIVITY); 
init_userprefs($userdata); 
$arcade_version = $arcade->arcade_config('version');
//
// End session management 
//
//  Build the required information from what we have received.
//
$sql                    = '';
$mode                   = $arcade->pass_var('func', '');
$gameData               = $arcade->pass_var('gameData', '');
$game_id                = $arcade->pass_var('gid' , 0);
$arcade->score          = $arcade->pass_var('score', 0);
$arcade->user_id        = $userdata['user_id'];
$session_info           = $arcade->get_session();
//
//  Process the pnFlashGame command
//
switch($mode)
{
  case "storeScore":
//
//  pnFlashGames Score save routine
//
    if(($session_info['score_type'] == ARCADE_pnFlashGames) || ($session_info['score_type'] == 0))
    {
      $arcade->game_name  = $session_info['game_name'];
      $arcade->score_type = ARCADE_pnFlashGames;
      $arcade->newscore();

      print "&opSuccess=true&endvar=1";
    }
    else
    {
      print "&opSuccess=Missing info&endvar=1";
      $arcade->log_game('BAD_GAME', $this->game_name. '=>' . $this->score);
    }
    
    break;

  case "loadGame":
//
//  Load a Saved Game (allows for continue option)
//
    if($session_info && $userdata['user_id'] != ANONYMOUS)
    {
      $sql = "SELECT gameData FROM " . iNA_SCORES . " 
        WHERE player_id = " . $userdata['user_id'] . "
        AND game_name = '" . $session_info['game_name'] . "'";
      if(!($result = $db->sql_query($sql)))
      {
        $arcade->log_error(__LINE__, __FILE__, $sql);
      }
      $game_info = $db->sql_fetchrow($result);

      $gameData = 'gameData=' . $game_info['gameData'] . "&opSuccess=true&endvar=1";	
      urlencode($gameData);
      print $gameData;
    }  
    else
    {
      print "&opSuccess=Missing info&endvar=1";
    }

    break;
    
  case "saveGame":
//
//  Save a part, NOT THE SCORE, But the users position etc.
//
    if(($session_info) && ($userdata['user_id'] != ANONYMOUS) && ($gameData))
    {
      $sql = "UPDATE " . iNA_SCORES . " SET gameData = '" . $gameData . "'
          WHERE player_id = " . $userdata['user_id'] . "
          AND game_name = '" . $session_info['game_name'] . "'";
       if(!($result = $db->sql_query($sql)))
      {
        $arcade->log_error(__LINE__, __FILE__, $sql);
      }

      print "&opSuccess=true&endvar=1";
    }
    else
    {
      $arcade->log_game('BAD_GAME', $this->game_name. '=>' . $this->score . ' ' . $gameData);
      print "&opSuccess=Missing info&endvar=1";
    }

    break;
  
  default:
    $arcade->log_game('BAD_GAME', $this->game_name. '=>' . $this->score);
    print "&opSuccess=Missing info&endvar=1";
    
    break;

}
//
//  Arcade LOG
//
$log = 'pnFlashGames ';
foreach($HTTP_POST_VARS as $key => $value)
{
  $log .= addslashes($key) . '=>' . addslashes(htmlspecialchars($value)) . ' ';
}
$arcade->log_game('GAME', $log);

?>
